function init()
body = FindBody(minebody)
mineshape = FindShape(mineshape)
click = LoadSound("clickup.ogg")
beep = LoadSound("MOD/tools/hammer/landmine/torchmine.ogg")
exploded = false
beepTimer = 1
time = 0
realtime = 0
armtime = 1
maxrealtime = 30

	local ct = GetCameraTransform()
	local startpos = TransformToParentPoint(ct, Vec(0, 0, -1))
	local fwdpos = TransformToParentPoint(ct, Vec(0, 0, -10))
	local direction = VecSub(fwdpos, startpos)
	SetBodyVelocity(body, direction)
    SetBodyAngularVelocity(body, Vec(0,math.random(20,30),0))
end

function tick(dt)
	if not armed then
		armtime = armtime - dt
		PointLight(GetBodyTransform(body).pos, 1,0.3,0.3,5)
		if armtime < 0 then
			armed = true
		end
	end
	if not exploded and armed then
		DrawBodyOutline(body,1,0.2,0.2,1)
		realtime = realtime + dt
		minePos = GetBodyTransform(body).pos
		a = VecAdd(minePos, Vec(-0.225, -0.15, -0.225))
		b = VecAdd(minePos, Vec(0.225, 0.25, 0.225))
		local enemyBody = GetNearestShape(FindShapes("Flesh"),minePos)
		playerPos = GetBodyTransform(enemyBody).pos
		dist = VecLength(VecSub(playerPos, minePos))
		local broken = IsBodyBroken(body)
		QueryRequire("dynamic physical")
		QueryRejectBody(body)
		list = QueryAabbBodies(a, b)
		
		if #list ~= 0 or broken or maxrealtime < realtime then
			Explosion(minePos, 1)
			exploded = true
		end

		if dist < 0.6 then
			stepped = true
		end
		if stepped then
			time = time+1
			if time == 50 then
				Explosion(minePos, 1)
				exploded = true
			end
		end

		if beepTimer > dist * 0.08 and dist < 15 then
			PlaySound(beep, minePos, 1)
			beepTimer = 0
			PointLight(GetBodyTransform(body).pos, 1,0,0,25)
			for i=1,10 do
				smoke()
			end
			SetShapeEmissiveScale(mineshape, 1)
		else
			SetShapeEmissiveScale(mineshape, 0)
		end
		beepTimer = beepTimer + dt
	end
end

function smoke()
    --spawn sparks
		ParticleReset()
		ParticleTile(6)
		ParticleRotation(10)
		ParticleRadius(0.015)
		--ParticleSticky(0,1)
		ParticleColor(1,0,0)
		ParticleEmissive(12/10)
		ParticleGravity(1)
		ParticleDrag(0, 1)
		ParticleCollide(0)
		for i=1,math.random(1,1) do
			SpawnParticle(minePos,Vec(math.random(-4,4),math.random(-4,4),math.random(-4,4)),1)
		end

    --spawn sparks
		ParticleReset()
		ParticleType("smoke")
		ParticleTile(0)
		ParticleCollide(0)
		ParticleRotation(10)
		ParticleRadius(0.1)
		--ParticleSticky(0,1)
		ParticleColor(0.4, 0, 0)
		ParticleEmissive(12/40)
		ParticleAlpha(0.25)
		ParticleGravity(20)
		ParticleDrag(0, 1)
		for i=1,math.random(1,1) do
			SpawnParticle(minePos,Vec(math.random(-1,1),math.random(-1,1),math.random(-1,1)),1)
		end

	pcolor = math.random(1,2)
	if pcolor == 1 then
	ParticleColor(0.75, 0, 0)
	end
	if pcolor == 2 then
	ParticleColor(0.6, 0, 0)
	end
	ParticleEmissive(12/10)
	ParticleCollide(0)
	ParticleTile(6)
	ParticleRadius(0.02)
	ParticleAlpha(1)
	ParticleGravity(0)
	ParticleFlags(256)
	for i=1,math.random(1,1) do
		SpawnParticle(minePos,Vec(math.random(-2,2),math.random(-2,2),math.random(-2,2)),1)
	end
end

function GetNearestShape(bodies, point)
    local closest = 0
    local closestDist = 99999
    for i=1, #bodies do
        dist = VecLength(VecSub(GetShapeWorldTransform(bodies[i]).pos, point))
        if dist < closestDist then
            closest = i
            closestDist = dist
        end
    end

    return bodies[closest-1], dist
end