function init()
	pod = FindBody("pod")
	door = FindShape("door")

	timer = 0
	maxtimer = 90
	SetBodyVelocity(pod,Vec(0,-10,0))
end

function tick(dt)
	if not set then
		if not done then
			podT = GetBodyTransform(pod)
			ConstrainOrientation(pod, 0, podT.rot, QuatEuler(0,90,0))
			ShakeCamera(0.2)
			--SetBodyVelocity(pod,Vec(0,-12,0))
			QueryRejectBody(pod)
			QueryRequire("physical static large")
			hit, p, n, s = QueryClosestPoint(podT.pos, 1)
		else
			SetBodyTransform(pod, Transform(p,GetBodyTransform(pod).rot))
			SetBodyDynamic(pod, false)
			SetBodyVelocity(pod,Vec(0,0,0))
			ShakeCamera(0.75)
			QueryRequire("physical dynamic")
			local list = QueryAabbBodies(VecAdd(podT.pos,Vec(-2, -1, -2)), VecAdd(podT.pos,Vec(2, 7, 2)))
			for i=1, #list do
				local body = list[i]
				--Delete(body)
			end
			GroundSmoke()
			Spawn("MOD/enemy/monster.xml",GetBodyTransform(pod))
			SetBool("level.monster.grounded", true)
			Delete(pod)
			set = true
		end
		if hit then
			if GetShapeVoxelCount(s) < 50000 then
				--SetBodyVelocity(pod,Vec(0,120,0))
				--Shoot(p, Vec(0,-1,0), "bullet", 1)
			else
				done = true
			end
		end
	end
end

function GroundSmoke()
		ParticleReset()
		ParticleTile(6)	
		ParticleType("plain")
		--ParticleOrientation("normalup")
		ParticleRadius(0.08,0.025)
		ParticleSticky(0,1)
		local mattype, r2, g2, b2, a2 = GetShapeMaterialAtPosition(s, p)
		ParticleColor(r2, g2, b2)
		ParticleAlpha(a2,0)
		ParticleGravity(-5,-20)
		ParticleDrag(0, 0.1)
		ParticleRotation(0)
		ParticleStretch(1,0)
		ParticleCollide(0,1)
		for i=1,100 do
			shadeVariety = math.random(-10,10)/110
			ParticleColor(r2+shadeVariety, g2+shadeVariety, b2+shadeVariety)
			SpawnParticle(GetBodyTransform(pod).pos,TransformToParentVec(GetBodyTransform(pod),Vec(math.random(-12,12),math.random(8,20),math.random(-12,12))),math.random(6,9))
		end
		ParticleReset()
		ParticleTile(0)	
		ParticleType("smoke")
		--ParticleOrientation("normalup")
		ParticleRadius(0.4,0.05)
		ParticleSticky(0)
		local mattype, r3, g3, b3, a3 = GetShapeMaterialAtPosition(s, p)
		ParticleColor(r3, g3, b3)
		ParticleAlpha(a3,0)
		ParticleGravity(5)
		ParticleDrag(0, 0.1)
		ParticleRotation(0)
		ParticleStretch(0)
		ParticleCollide(0)
		for i=1,100 do
			SpawnParticle(GetBodyTransform(pod).pos,TransformToParentVec(GetShapeWorldTransform(smokeLoc),Vec(math.random(-4,4),math.random(0,2),math.random(1,3))),15)
		end
end