function init()
	--{name = "", dialogue = {{""}}}
	--dialogue:


	logs = {
	{name = "Codename COSMONAUT - Entry 234", charTime = 0.06, dialogue = {
        "IT HAS ESCAPED",
        "THE ANSWERS LIE WITHIN US",
		"FOLLOW THE TABLET",
        "FIX THE PORTAL",
        "TELL OUR FAMILIES",
        "IT IS STRONGER THAN YOU",
        "IT IS SMARTER",
        "AND WHEN YOU FIND YOURSELF STARING INTO ITS PIERCING EYES",
        "FORGET TO HESITATE",
        "AND RUN FASTER THAN WE COULD"} 
	},

	{name = "Codename COSMONAUT - Entry 101", charTime = 0.06, dialogue = {
		"x.",
		"x.",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x"}
	},
	
	{name = "Codename COSMONAUT - Entry 138", charTime = 0.06, dialogue = {
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x"}
	},
	
	{name = "Codename COSMONAUT - Entry 233", charTime = 0.06, dialogue = {
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x",
		"x"}
	},

	}

	topborder = 20
	sideborders = 40

	titleSize = 30
	fontSize = 24 -- 24 is pretty good
	font = "MOD/Analog2.ttf"
	textSound = LoadSound("clickup.ogg")
	bg = true

	lognum = 1
	linenum = 1
	character = 0
	timer = 0
	timernoise = 0
	textState = "none"
	maxtimer = 0.025
	number = 1
end

function tick(dt)
	
end

function draw(dt)
	UiPush()
	--DebugWatch("textState", textState)
	timer = timer + dt

	lines = #logs[lognum].dialogue
	line = logs[lognum].dialogue[linenum]
	--textState = GetString("savegame.mod.dialogue.state")
	--image = GetString("savegame.mod.dialogue.image")

	if InputPressed("usetool") then
		if textState == "done" then
			linenum = linenum + 1
			character = 0
			textState = "talking"

		elseif textState == "end" then
			--linenum = 1
			--character = 0
			--textState = "none"
			SetPlayerScreen(0)
			if lognum == 1 then
			SetBool("level.introDone", true)
			end

			for j=2, lines do
				--ClearKey("savegame.mod.dialogue.lines.line"..j)
			end

		elseif textState == "talking" then
			character = #line --skip to end
			
			if linenum + 1 > lines then --if no more lines
				textState = "end"
			else
				textState = "done"
			end

		elseif textState == "none" then
			textState = "talking"
		end
	end



	if timer > logs[lognum].charTime and textState == "talking" then

		timer = 0
		character = character + 1

		if character > string.len(line) then --if line over
			if linenum + 1 > lines then --if no more lines
				textState = "end"
			else
				textState = "done"
			end
		else
			if string.sub(line, character, character) ~= " " then --if space
				PlaySound(textSound)
			end
		end
	end

	if textState ~= "none" then
		
		random1 = math.random(-100,100)/450
		random2 = math.random(-100,100)/450
		UiTranslate(sideborders, topborder)
		
		if bg then
			UiPush()
				tw, th = TotalTextSize(logs[lognum])
			UiPop()
		end

		UiColor(1, 1, 1, 1)
		DrawText(logs[lognum].name, titleSize, 0)
		UiColor(1, 0, 0, 1)

		for i=1, linenum-1 do
			text = logs[lognum].dialogue[i]
			DrawText(text, fontSize, shake)
		end

		temp = string.sub(line, 1, character)
		DrawText(temp, fontSize, shake)
	end

	SetString("savegame.mod.dialogue.state", textState)
	UiPop()
	UiPush()
		UiAlign("")
		UiColor(1, 1, 1, 0.075)
		UiImageBox("MOD/UI/lines.png",UiWidth(),UiHeight())
		
	if timer > maxtimer then
		number = number + 1
		if number > 3 then
			number = 1
		end
		timernoise = 0
	else
		timernoise = timernoise + dt
	end

	UiImageBox("MOD/UI/noise"..number..".png",UiWidth(),UiHeight())
		UiColor(0.8, 0.8, 0.8, 0.5)
		UiTranslate(720,490)
		UiFont(font, size)
		UiAlign("right bottom")
		UiTextOutline(0, 0, 0, 1, 0.4)
		UiTranslate(0,10)
		if textState ~= "end" then
			UiText("PRESS "..string.upper(GetString("game.input.usetool")).." TO PROGRESS LOG")
		end
		--UiTranslate(0,10)
		--UiText("PRESS "..string.upper(GetString("game.input.interact")).." TO EXIT LOG")
	UiPop()
end

function TotalTextSize(log)
	widest = 0
	height = 0

	UiPush()
	UiFont(font, fontSize)
	UiWordWrap(UiWidth() - (2 * sideborders))

	height = height + (titleSize * 1.1)

	for i, line in pairs(log.dialogue) do
		w, h = UiGetTextSize(line)

		if w > widest then
			widest = w
		end

		height = height + (h * 1.1)
	end

	UiPop()

	return widest, height
end

function DrawText(text, size, shakeAmount)

	UiPush()
		UiFont(font, size)
		UiAlign("left top")
		UiTextOutline(0, 0, 0, 1, 0.4)

		UiWordWrap(UiWidth() - (2 * sideborders))

		w, h = UiText(text)
		--UiRect(w, h)
	UiPop()
	
	UiTranslate(0, h * 1.1)	
end