--credits to TallTim for the original script.
instLocHandleArray = {} 
storLocHandleArray = {} 
instLocPosArray = {} 
storLocPosArray = {} 
partHandleArray = {} 
partNameArray = {} 
partStateCol_1_Array = {} 
partStateCol_2_Array = {} 
partStateCol_3_Array = {} 
partStateCol_4_Array = {}
installGhostHandle = 0
storageGhostHandle = 0
touchFlag = false
ghostPathRoot = "MOD/main/prefabs/" 
voxPathRoot = "MOD/main/prefabs/" 
function populateLocations() 
	instLocHandleArray = FindLocations("Installed", true)
	storLocHandleArray = FindLocations("Storage", true)
	for j=1, #instLocHandleArray do 
		tempLocTransform = GetLocationTransform(instLocHandleArray[j])
		tempLocPosition = tempLocTransform.pos
		instLocPosArray[j] = tempLocPosition
	end
	for k=1, #storLocHandleArray do 
		tempLocTransform = GetLocationTransform(storLocHandleArray[k]) 
		tempLocPosition = tempLocTransform.pos
		storLocPosArray[k] = tempLocPosition		
	end
end
function populatePartStates() 
	local tmpName = "None"
	partHandleArray = FindShapes("part", true) 
	if #partHandleArray == 0 then
	end
	if #partHandleArray > 0 then 
		for h=1, #partHandleArray do
			tmpName = GetTagValue(partHandleArray[h], "name") 
			table.insert(partNameArray, tmpName) 
			table.insert(partStateCol_1_Array, "Installed") 
			table.insert(partStateCol_2_Array, "None")
			table.insert(partStateCol_3_Array, "None")
			table.insert(partStateCol_4_Array, "None")
		end
	end
end
function Round(x, myPrecision) 
	local n = myPrecision 
	local product = 0
	if x ~= nil then
		n = math.pow(10, n or 0)
		x = x * n
		if x >= 0 then 
			x = math.floor(x + 0.5) 
		else 
			x = math.ceil(x - 0.5) 
		end
		local product = x / n
	end
    return product 
end
function rejectShapes(arr) 
	for i=1, #arr do 
		QueryRejectShape(arr[i])
	end
end
function getPosCoordinates(myHandle) 
		local myPos_X = 0
		local myPos_Y = 0
		local myPos_Z = 0
		if myHandle ~= 0 then
			local myTransform = GetShapeWorldTransform(myHandle) 
			local myPosition = myTransform.pos
			myPos_X = myPosition[1]
			myPos_Y = myPosition[2]
			myPos_Z = myPosition[3]
		end
	return myPos_X, myPos_Y, myPos_Z
end
function getEulerRotation(myHandle) 
	local myRot_X = 0
	local myRot_Y = 0
	local myRot_Z = 0
	if myHandle ~= 0 then
		local myTransform = GetShapeWorldTransform(myHandle)
		local myQuatRot = myTransform.rot
		myRot_X, myRot_Y, myRot_Z = GetQuatEuler(myQuatRot)
	end
	return myRot_X, myRot_Y, myRot_Z
end
function findPartName(myHandle) 
	local tmpName = "None"
	local tmpIndex = 0
	if myHandle == 0 then 
	end
	for p=1, #partHandleArray do
		if myHandle == partHandleArray[p] then 
			tmpName = partNameArray[p] 
			tmpIndex = p 
		end
	end
	return tmpName, tmpIndex 
end
function updatePartHandle(myPartName, myNewPartHandle) 
	local tmpPartIndex = 0
	for p=1, #partNameArray do
		if myPartName == partNameArray[p] then 
			partHandleArray[p] = myNewPartHandle
			tmpPartIndex = p 
		end
	end
	if tmpPartIndex == 0 then 
	end
end
function bodyDynamicCheck(myShapeHandle) 
	local tmpBodyHandle = 0
	if myShapeHandle == 0 then
	end
	if myShapeHandle ~= 0 and myShapeHandle ~= groundHandle then 
		tmpBodyHandle = GetShapeBody(myShapeHandle) 
		tmpDynamicFlag = IsBodyDynamic(tmpBodyHandle) 
		if tmpDynamicFlag == false then 
			SetBodyDynamic(tmpBodyHandle, true)
		end
	end
end
function probeScene() 
	local myPlayerForwardVec = TransformToParentVec(GetCameraTransform(),Vec(0,0,-1))
	local myRayHit = false
	local myShapeDistance = 0
	local myWorldNormalList = {}
	rejectShapes(rejectedObjects) 
	myRayHit, myShapeDistance, myWorldNormalList, myShapeHandle = QueryRaycast(GetCameraTransform().pos, myPlayerForwardVec, 10, 0, false)
	return myRayHit, myShapeHandle 
end
function spawnTargetGhost(myPartName, myState) 
	local partGhostPath = "None"
	local myGhostPath = "None"
	local ghostTag = "None"
	if myPartName == "None" then
	end
	myGhostPath = ghostPathRoot .. myPartName .. "_Ghost.xml"
	if myState == "Storage" then
		for i=1, #storLocHandleArray do
			myTempName = GetTagValue(storLocHandleArray[i], "name")
			if myTempName == myPartName then  
				myTempLocation = storLocPosArray[i] 
				storageSpawnLoc = myTempLocation 
			end
		end
		if partStateCol_1 == "Installed" then
			Spawn(myGhostPath, Transform(storageSpawnLoc), true)
			partStateCol_1_Array[shapeIndex] = "Pending"
			partStateCol_4_Array[shapeIndex] = "TouchStorageGhost"
		end
		ghostTag = myPartName .. "StorGhost"
		storageGhostHandle = FindShape(ghostTag, true) 
	end	
	if myState == "Installed" then
		for j=1, #instLocHandleArray do
			myTempName = GetTagValue(instLocHandleArray[j], "name")
			if myTempName == myPartName then  
				myTempLocation = instLocPosArray[j] 
				installSpawnLoc = myTempLocation 
			end
		end
		if partStateCol_1 == "Stored" then
			Spawn(myGhostPath, Transform(installSpawnLoc), true)
			partStateCol_1_Array[shapeIndex] = "Pending"
			partStateCol_4_Array[shapeIndex] = "TouchInstallGhost"
		end
		ghostTag = myPartName .. "StorGhost"
		installGhostHandle = FindShape(ghostTag, true) 
	end
end
function partPoll(myPartPollHandle, myPartPollName) 
	local tmpBodyHandle = 0
	local tmpOldBodyHandle = 0
	local tmpShapeArray = {}
	if myPartPollHandle == 0 then
	end
	if myPartPollHandle ~= 0 then
		if partStateCol_4 == "TouchStorageGhost" then
			touchFlag = IsShapeTouching(myPartPollHandle, storageGhostHandle)
		end
		if partStateCol_4 == "TouchInstallGhost" then
			touchFlag = IsShapeTouching(myPartPollHandle, installGhostHandle)
		end	
		if touchFlag == true then 
			if partStateCol_4 == "TouchStorageGhost" then
				Delete(storageGhostHandle) 
				storageGhostHandle = 0 
				partStateCol_4_Array[shapeIndex] = "None"
				partStateCol_1_Array[shapeIndex] = "Stored"
				tmpOldBodyHandle = GetShapeBody(myPartPollHandle)
				Delete(tmpOldBodyHandle) 
				Delete(myPartPollHandle) 
				partStateCol_3_Array[shapeIndex] = "None"
				partStateCol_2_Array[shapeIndex] = "None"
				if myPartPollName == "PortalTop" then
					SetBool("savegame.mod.Specimen.PortalTopStorage", true)
				elseif myPartPollName == "PortalSide" then
					SetBool("savegame.mod.Specimen.PortalSideStorage", true)
				elseif myPartPollName == "Battery" then
					SetBool("savegame.mod.Specimen.BatteryStorage", true)
				end
				tmpSpawnPath = voxPathRoot .. myPartPollName .. ".xml"
				Spawn(tmpSpawnPath, Transform(storageSpawnLoc), true)
				tmpBodyHandle = FindBody(myPartPollName, true) 
				tmpShapeArray = GetBodyShapes(tmpBodyHandle) 
				updatePartHandle(myPartPollName, tmpShapeArray[1]) 
				touchFlag = false
				myPartPollHandle = 0 
				--SetBool("savegame.mod.StorageSpawn.".. myPartPollName, true)


			end
			if partStateCol_4 == "TouchInstallGhost" then
				Delete(installGhostHandle) 
				installGhostHandle = 0 
				partStateCol_4_Array[shapeIndex] = "None"
				partStateCol_1_Array[shapeIndex] = "Installed"
				tmpOldBodyHandle = GetShapeBody(myPartPollHandle)
				Delete(tmpOldBodyHandle) 
				Delete(myPartPollHandle) 
				partStateCol_3_Array[shapeIndex] = "None"
				partStateCol_2_Array[shapeIndex] = "None"
				tmpSpawnPath = voxPathRoot .. myPartPollName .. ".xml"
				Spawn(tmpSpawnPath, Transform(installSpawnLoc), true)
				tmpBodyHandle = FindBody(myPartPollName, true) 
				tmpShapeArray = GetBodyShapes(tmpBodyHandle) 
				updatePartHandle(myPartPollName, tmpShapeArray[1]) 
				touchFlag = false
				myPartPollHandle = 0 
			end
		end 
	end 
end
function selectPart()
	probeHit = false
	shapeHandle = 0
	shapeName = "None"
	shapeIndex = 0 
	partStateCol_1 = "None" 
	partStateCol_2 = "None" 
	partStateCol_3 = "None" 
	partStateCol_4 = "None" 
	probeHit, shapeHandle = probeScene() 
	if probeHit == true then 
		shapeName, shapeIndex = findPartName(shapeHandle)
		if shapeName ~= "None" then 
			partStateCol_1 = partStateCol_1_Array[shapeIndex] 
			partStateCol_2 = partStateCol_2_Array[shapeIndex] 
			partStateCol_3 = partStateCol_3_Array[shapeIndex] 
			partStateCol_4 = partStateCol_4_Array[shapeIndex] 
		end
		shapePos_X, shapePos_Y, shapePos_Z = getPosCoordinates(shapeHandle) 
		shapeRot_X, shapeRot_Y, shapeRot_Z = getEulerRotation(shapeHandle) 
	end
	if InputDown("rmb") then
		if probeHit == true and shapeName ~= None then 
			if partStateCol_2 == "Selected" then 
				bodyDynamicCheck(shapeHandle)
				partStateCol_3_Array[shapeIndex] = "Manipulate"
			end
		end
	end
	if InputDown("rmb") then
		if probeHit == true and shapeName ~= None then 
			if partStateCol_2 == "None" then
				partStateCol_2_Array[shapeIndex] = "Selected" 
			end
			if partStateCol_1 == "Installed" then
				if shapeName == "PortalTop" then
					if not GetBool("savegame.mod.Specimen.PortalTopStorage") then
						spawnTargetGhost(shapeName, "Storage")
					end
				elseif shapeName == "PortalSide" then
					if not GetBool("savegame.mod.Specimen.PortalSideStorage") then
						spawnTargetGhost(shapeName, "Storage")
					end
				elseif shapeName == "Battery" then
					if not GetBool("savegame.mod.Specimen.BatteryStorage") then
						spawnTargetGhost(shapeName, "Storage")
					end
				end
			end
			if partStateCol_1 == "Stored" then
				spawnTargetGhost(shapeName, "Installed")			
			end
		end
	end
end	

function initPart()
	if GetBool("savegame.mod.Specimen.PortalTopStorage") == true then
		local body = FindBody("PortalTop", true)
		Delete(body)
		local location = FindLocation("PortalTop", true)
		local locationTransform = GetLocationTransform(location)
		--SetBodyTransform(body, locationTransform)
		Spawn(voxPathRoot .. "PortalTop.xml", locationTransform, true)
	--	SetInt("savegame.mod.portalPartValue",2)
		if GetInt("savegame.mod.ObjectiveValue") == 10 then
		--	SetInt("savegame.mod.ObjectiveValue",1)
		end
		tmpBodyHandle = FindBody("PortalTop", true) 
		tmpShapeArray = GetBodyShapes(tmpBodyHandle) 
		updatePartHandle("PortalTop", tmpShapeArray[1]) 
	end
	if GetBool("savegame.mod.Specimen.PortalSideStorage") == true then
		local body = FindBody("PortalSide", true)
		Delete(body)
		local location = FindLocation("PortalSide", true)
		local locationTransform = GetLocationTransform(location)
		--SetBodyTransform(body, locationTransform)
		Spawn(voxPathRoot .. "PortalSide.xml", locationTransform, true)
		--SetInt("savegame.mod.portalPartValue",3)
		if GetInt("savegame.mod.ObjectiveValue") == 15 then
		--	SetInt("savegame.mod.ObjectiveValue",16)
		end
		tmpBodyHandle = FindBody("PortalSide", true) 
		tmpShapeArray = GetBodyShapes(tmpBodyHandle) 
		updatePartHandle("PortalSide", tmpShapeArray[1]) 
	end
	if GetBool("savegame.mod.Specimen.BatteryStorage") == true then
		local body = FindBody("Battery", true)
		Delete(body)
		local location = FindLocation("Battery", true)
		local locationTransform = GetLocationTransform(location)
		--SetBodyTransform(body, locationTransform)
		Spawn(voxPathRoot .. "Battery.xml", locationTransform, true)
		--SetInt("savegame.mod.portalPartValue",1)
		if GetInt("savegame.mod.ObjectiveValue") == 4 then
		--	SetInt("savegame.mod.ObjectiveValue",5)
		end
		tmpBodyHandle = FindBody("Battery", true) 
		tmpShapeArray = GetBodyShapes(tmpBodyHandle) 
		updatePartHandle("Battery", tmpShapeArray[1]) 
	end
end

function init() 
	populateLocations() 
	populatePartStates() 
	initPart()
	groundHandle = FindShape("ground", true) 
	rejectedObjects = {groundHandle} 
	savedGhost1 = false
	savedGhost2 = false
	savedGhost3 = false
end

function tick() 
	pT = FindBody("PortalTop", true)
	pS = FindBody("PortalSide", true)
	bY = FindBody("Battery", true)

    selectPart()

    if savedGhost1 == false then
        if GetBool("savegame.mod.Specimen.BatteryStorage") == true then
			if GetInt("savegame.mod.ObjectiveValue") == 4 then
				SetInt("savegame.mod.ObjectiveValue",5)
				SetInt("savegame.mod.portalPartValue",1)
			end
            savedGhost1 = true
        end
    end

    if savedGhost2 == false then
        if GetBool("savegame.mod.Specimen.PortalSideStorage") == true then
			if GetInt("savegame.mod.ObjectiveValue") == 10 then
				SetInt("savegame.mod.ObjectiveValue",11)
				SetInt("savegame.mod.portalPartValue",2)
			end
            savedGhost2 = true
        end
    end

    if savedGhost3 == false then
        if GetBool("savegame.mod.Specimen.PortalTopStorage") == true then
			if GetInt("savegame.mod.ObjectiveValue") == 15 then
				SetInt("savegame.mod.ObjectiveValue",16)
				SetInt("savegame.mod.portalPartValue",3)
			end
            savedGhost3 = true
        end
    end

	if GetBool("savegame.mod.Specimen.BatteryStorage") == false and GetInt("savegame.mod.ObjectiveValue") == 4 then
		DrawBodyOutline(bY,1,0,0,1)
	end
	if GetBool("savegame.mod.Specimen.PortalTopStorage") == false and GetInt("savegame.mod.ObjectiveValue") == 10 then
		DrawBodyOutline(pT,1,0,0,1)
	end
	if GetBool("savegame.mod.Specimen.PortalSideStorage") == false and GetInt("savegame.mod.ObjectiveValue") == 15 then
		DrawBodyOutline(pS,1,0,0,1)
	end

	selectPart()
	if partStateCol_3 == "Manipulate" then
		partPoll(partHandleArray[shapeIndex], partNameArray[shapeIndex]) 
	end

end