breaks = {}
targetbodies = {}
targetshapes = {}
targetjoints = {}
targetlocations = {}
targetlights = {}
targettriggers = {}
targetscreens = {}
targetvehicles = {}

function init()
    SetBool("onsvrg.break.refresh",true)
	refresh()

    --activatesound = LoadSound("activatesound")
    --deactivatesound = LoadSound("deactivatesound")
    --togglesound = LoadSound("togglesound")
    --locksound = LoadSound("locksound")
    --unlocksound = LoadSound("unlocksound")
end

function tick(dt)
    if GetBool("onsvrg.break.refresh") then
        refresh()
    end
	for i = 1, #breaks do
        if IsShapeBroken(breaks[i]) then
            local breaktransform = GetShapeLocalTransform(breaks[i])
            local t = "activate"
            local targettag = ""
            --
            local level = GetTagValue(breaks[i], "level")
            if level ~= "" then
                StartLevel(level, "MOD/"..level..".xml")
            end
            --
            
            if GetTagValue(breaks[i], "target") ~= "" then
                targettag = GetTagValue(breaks[i],"target")                  
            end

            if GetTagValue(breaks[i], "break") ~= "" then
                t = GetTagValue(breaks[i],"break")
            end
            if t == "activate" then
                --PlaySound(activatesound)                    
                --SetShapeEmissiveScale(breaks[i],0)
                activate(targettag)
                --breaktransform.pos[2] = breaktransform.pos[2] - 0.1
                --SetShapeLocalTransform(breaks[i], breaktransform)
            end
            if t == "deactivate" then
                --PlaySound(deactivatesound)                    
                --SetShapeEmissiveScale(breaks[i],1)
                deactivate(targettag)
                --breaktransform.pos[2] = breaktransform.pos[2] + 0.1
                --SetShapeLocalTransform(breaks[i], breaktransform)
            end
            if t == "toggle" then
                --PlaySound(togglesound)                    
                toggle(targettag)
            end
            if t == "lock" then
                --PlaySound(locksound)
                lock(targettag)
            end
            if t == "unlock" then
                --PlaySound(unlocksound)
                unlock(targettag)
            end
        end
	end
end

function refresh()
    breaks = FindShapes("break",true)
    for i = 1, #breaks do
        local t = "activate"
        if GetTagValue(breaks[i], "break") ~= "" then
            t = GetTagValue(breaks[i],"break")
        end
        type = t
    end
    SetBool("onsvrg.break.refresh",false)
end

function activate(tag)
    --DebugPrint("break activate")
    setstatus(tag,"activate")
end

function deactivate(tag)
    --DebugPrint("break deactivate")
    setstatus(tag,"deactivate")
end

function toggle(tag)
    --DebugPrint("break toggle tag: "..tag)
    setstatus(tag,"toggle")
end

function lock(tag)
    --DebugPrint("break lock")
    setstatus(tag,"lock")
end

function unlock(tag)
    --DebugPrint("break unlock")
    setstatus(tag,"unlock")
end

function setstatus(tag,status)
    targetjoints = FindJoints(tag, true)
    for i = 1, #targetjoints do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do
            SetTag(targetjoints[i], status)
        end
    end

    targetbodies = FindBodies(tag, true)
    for i = 1, #targetbodies do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do            
            SetTag(targetbodies[i], status)
        end
    end

    targetshapes = FindShapes(tag, true)
    for i = 1, #targetshapes do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do
            SetTag(targetshapes[i], status)
        end
    end

    targetlocations = FindLocations(tag, true)
    for i = 1, #targetlocations do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do            
            SetTag(targetlocations[i], status)
        end
    end

    targetlights = FindLights(tag, true)
    for i = 1, #targetlights do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do            
            SetTag(targetlights[i], status)
        end
    end

    targettriggers = FindTriggers(tag, true)
    for i = 1, #targettriggers do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do
            SetTag(targettriggers[i], status)
        end
    end

    targetscreens = FindScreens(tag, true)
    for i = 1, #targetscreens do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do
            SetTag(targetscreens[i], status)
        end
    end

    targetvehicles = FindVehicles(tag, true)
    for i = 1, #targetvehicles do
        local interactions = ListKeys("onsvrg.interactions")
        for j=1, #interactions do
            SetTag(targetvehicles[i], status)
        end
    end
end